;; (require 'session)
;; (add-hook 'after-init-hook 'session-initialize)
(desktop-save-mode t)
(setq history-length 500
      desktop-dirname "~/.emacs.d/desktop-save/")

(-map (lambda (element)
        (add-to-list 'desktop-globals-to-save element))
      '(grep-history
        grep-find-history
        find-args-history
        extended-command-history
        read-expression-history
        default-input-method
        input-method-history
        query-replace-history
        compile-history
        string-rectangle-history
        regexp-history
        dired-shell-command-history
        dired-regexp-history
        shell-command-history
        org-tags-history
        minibuffer-history
        erc-server-history-list
        cp/activity-history
        LaTeX-environment-history))

(desktop-auto-save-enable)
(setq desktop-save 'ask-if-exists
      use-file-dialog nil)
(defun cp/backup-desktop-file ()
  (let ((new-filename (->> (shell-command-to-string "date -Is")
                           (replace-regexp-in-string "\n" "")
                           (concat "~/.emacs.d/.emacs.desktop."))))
    (copy-file "~/.emacs.d/.emacs.desktop" new-filename)))
(defun cp/cleanup-desktop-backups ()
  (let ((desktop-file-backups (-> (concat "find ~/.emacs.d/ -maxdepth 1 -type f |"
                                          " grep -E \"\.emacs\.desktop\.[0-9]{4}-[0-9]{2}-[0-9]{2}T[0-9]{2}:[0-9]{2}:[0-9]{2}[-+]?[0-9]{2}:?[0-9]{2}\"")
                                  (shell-command-to-string )) )))
  (if (> 10 )))
;; ;; this one created loads and loads of backups
;; (add-hook 'desktop-save-hook 'cp/backup-desktop-file)
;; ;; not enough space for this - wasteful
;; (add-hook 'kill-emacs-hook 'cp/backup-desktop-file)
