(setq TeX-auto-save t
      TeX-parse-self t
      TeX-engine 'xetex
      ;; 2017-10-14T18:55:05+0530
      TeX-view-program-selection '(((output-dvi has-no-display-manager)
                                    "dvi2tty")
                                   ((output-dvi style-pstricks)
                                    "dvips and gv")
                                   (output-dvi "xdvi")
                                   (output-pdf "Zathura")
                                   (output-html "xdg-open")))
(add-hook 'tex-mode-hook 'TeX-source-correlate-mode)

;; 2017-10-19T09:19:34+0530 - these should be merged with
;; cp-forward-def/cp-backward-def in cp-lily...
(defun cp-backward-def ()
  (interactive)
  (push-mark)
  (re-search-backward "\\\\scene" nil t)
  (beginning-of-line)
  (recenter))

(defun cp-forward-def ()
  (interactive)
  (push-mark)
  (if (not (re-search-forward "\\\\scene" nil t 2))
      (re-search-forward "\\end{document}" nil t))
  (beginning-of-line)
  (recenter))

(cp-set-keys
 :keymap LaTeX-mode-map
 :bindings
 `((,(kbd "M-p") cp-backward-def)
   (,(kbd "M-n") cp-forward-def)))
