;; 2018-05-16T17:22:36+0530
(add-hook 'markdown-mode-hook '(lambda () (visual-fill-column-mode t)))
(add-hook 'markdown-mode-hook '(lambda () (visual-line-mode t)))
;; (add-hook 'markdown-mode-hook '(lambda () (turn-off-smartparens-mode)))

(autoload 'markdown-mode "markdown-mode" "autoload for markdown-mode" t)
(add-to-list 'auto-mode-alist '("\\.markdown\\'" . markdown-mode))
(add-to-list 'auto-mode-alist '("\\.md\\'" . markdown-mode))
;; (define-key markdown-mode-map (kbd "C-c C-o") 'markdown-follow-link-at-point)
;; 2018-01-02T18:45:27+0530
(setq markdown-command "cmark")
;; 2018-03-19T14:18:56+0530

(with-eval-after-load 'markdown-mode
  (setq markdown-css-paths '("style.css"))
  (cp-set-keys
   :keymap markdown-mode-map
   :bindings
   `(;; (,(kbd "M-n") org-drag-element-forward)
     ;; (,(kbd "M-p") org-drag-element-backward)
     (,(kbd "M-n") markdown-move-down)
     (,(kbd "M-p") markdown-move-up)
     ;; 2018-08-29T23:00:00+0530
     (,(kbd "C-c C--") org-cycle-list-bullet)
     (,[mouse-1] markdown-cycle)
     (,(kbd "C-c C-c C-n") markdown-cleanup-list-numbers)
     (,(kbd "C-c C-x C-n") markdown-next-link)
     (,(kbd "C-c C-x C-p") markdown-previous-link))))

(defun cp/copy-line-or-md-link (prefix-arg)
  (interactive "P")
  (save-excursion
    (beginning-of-line)
    (if (looking-at-p ".*http")
        (progn
          (re-search-line "http")
          (forward-char -4)
          (kill-new (thing-at-point 'url))))))
