;; mouse-1, 2, 3 - the usual suspects
;; mouse-4 and 5 - wheel up and wheel down
;; mouse-9 and 8 - 'forward' and 'backward' thumb buttons

(cp-set-keys
 :bindings
 '( ;; ([down-mouse-1]   mouse-set-point)
   ;; ([up-mouse-1]     er/expand-region)
   ([s-mouse-3]      bury-buffer)
   ([mouse-8]        delete-window)
   ;; (,(kbd "<mouse-9>")   keyboard-quit)
   ;; ([mouse-9]        buffer-menu)
   ([mouse-9]        ibuffer)
   ([C-mouse-9]      recentf-open-files)
   ([M-mouse-4]      next-buffer)
   ([M-mouse-5]      previous-buffer)
   ([M-mouse-8]      split-window-right)
   ([M-mouse-9]      split-window-below)
   ;; quitting from helm-mini - whether with keyboard-quit or
   ;; keyboard-escape-quit - "banishes" the mouse pointer to the
   ;; top-right corner!? wtf, helm.
   ;; (,(kbd "s-<mouse-9>") helm-mini)
   ))

(with-eval-after-load 'magit
  (define-key magit-status-mode-map [mouse-3] 'magit-section-toggle)
  ;; (define-key magit-status-mode-map [down-mouse-3] 'mouse-set-point)
  ;; (define-key magit-status-mode-map [up-mouse-3] 'magit-section-toggle)
  )

(with-eval-after-load 'org
  (define-key org-mode-map [mouse-1] 'org-cycle))

;; (require 'ediff)

;; (cp-set-keys
;;  :keymap ediff-mode-map
;;  :bindings
;;  '(([mouse-4] ediff-previous-difference)
;;    ([mouse-5] ediff-next-difference)))

;; (add-hook 'ediff-mode-hook
;;           #'(lambda ()
;;               (define-key ediff-mode-map [mouse-4] 'ediff-previous-difference)
;;               (define-key ediff-mode-map [mouse-5] 'ediff-next-difference)))

; window management (stumpwm) (written here so I know which ones I
; want to reserve for the future)
; super + mousewheel up/down - next/previous window
